package no.ntnu.idatt1002.demo.data.recipes;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class IngredientsAtHandTest {

    IngredientsAtHand ingredientsAtHand = new IngredientsAtHand();

    @BeforeEach
    void beforeEach() {
        ingredientsAtHand.addIngredient(FoodItem.LEMON);
        ingredientsAtHand.addIngredient(FoodItem.MILK);
        ingredientsAtHand.addIngredient(FoodItem.MINCED_MEAT);
    }


    @Test
    @DisplayName("The atHand method returns true/false correctly.")
    void atHandReturnsSuccessfully() {
        assertTrue(ingredientsAtHand.atHand(FoodItem.LEMON));
        assertFalse(ingredientsAtHand.atHand(FoodItem.YELLOW_CHEESE));
    }

    @Test
    @DisplayName("Ingredient is removed successfully and true is returned.")
    void removeIngredientSuccessfully() {
        int ingredientsAtStart = ingredientsAtHand.getIngredientsAtHand().size();
        assertTrue(ingredientsAtHand.removeIngredient(FoodItem.LEMON));
        assertEquals(ingredientsAtStart-1, ingredientsAtHand.getIngredientsAtHand().size());
    }

    @Test
    @DisplayName("Removing ingredient that is not in the collection, leaves it unchanged and returns false.")
    void removeIngredientNotInCollection() {

        assertFalse(ingredientsAtHand.removeIngredient(FoodItem.SALSA_SAUCE));
    }

}